<template>
  <q-page class="row flex-center background-login2 q-pa-lg">
    <q-card
      class="super-rounded-borders col-xl-3 col-lg-4 col-md-4 col-sm-8 col-xs-12"
      :style="style"
    >
      <q-card-section class="text-center q-pt-lg">
        <q-img
          src="~assets/logo.png"
          width="80%"
        />
      </q-card-section>

      <q-card-section>
        <form class="row flex-center q-gutter-y-sm">
          <q-input
            v-model="form.newPassword"
            :type="isPwd1 ? 'password' : 'text'"
            class="col-10 q-px-md"
            label="Nova Senha"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.newPassword.$error"
            @keyup.enter="$refs.repeatPassword.focus()"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                :name="isPwd1 ? 'visibility_off' : 'visibility'"
                @click="isPwd1 = !isPwd1"
              />
            </template>

            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.newPassword)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>

          <q-input
            ref="repeatPassword"
            v-model="form.repeatPassword"
            :type="isPwd2 ? 'password' : 'text'"
            class="col-10 q-px-md"
            label="Confirmação da Senha"
            color="primary"
            bottom-slots
            outlined
            dense
            :error="$v.form.repeatPassword.$error"
            @keyup.enter="recover(form)"
          >
            <template v-slot:append>
              <q-icon
                class="cursor-pointer"
                :name="isPwd2 ? 'visibility_off' : 'visibility'"
                @click="isPwd2 = !isPwd2"
              />
            </template>

            <template v-slot:error>
              <div
                v-for="(message, index) in errorMessages($v.form.repeatPassword)"
                :key="index"
                v-text="message"
              />
            </template>
          </q-input>
        </form>
      </q-card-section>

      <q-card-section class="row flex-center q-pb-sm">
        <div class="col-10 q-px-md q-pb-xl">
          <q-btn
            class="full-width"
            color="primary"
            label="Enviar"
            padding="12px"
            @click="recover(form)"
          />
        </div>
      </q-card-section>
    </q-card>
  </q-page>
</template>

<script>
import { required, minLength, maxLength, sameAs } from 'vuelidate/lib/validators'
import { ErrorMessagesMixin } from '../../mixin/error-messages'

export default {
  name: 'PageRecover',
  mixins: [ErrorMessagesMixin],
  data () {
    return {
      form: {
        newPassword: '',
        repeatPassword: ''
      },
      isPwd1: true,
      isPwd2: true
    }
  },
  validations: {
    form: {
      newPassword: {
        required,
        minLength: minLength(8),
        maxLength: maxLength(24)
      },
      repeatPassword: {
        sameAsPassword: sameAs('newPassword')
      }
    }
  },
  computed: {
    style () {
      return {
        maxWidth: '500px'
      }
    }
  },
  methods: {
    async recover ({ newPassword }) {
      this.$v.form.$touch()

      if (this.$v.form.$error) {
        return undefined
      }

      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'POST',
          url: `/Usuarios/reset-password?access_token=${this.$route.query.access_token}`,
          data: { newPassword }
        }

        await this.$axios(axiosConfig)

        this.axiosSuccess('Senha atualizada com sucesso', '/auth/login')
      } catch (err) {
        this.axiosCatch(err)
      } finally {
        this.$q.loading.hide()
      }
    }
  }
}
</script>
